// gcc bug.c -lphysfs -o bug
// ./bug

#include <stdio.h>
#include <physfs.h>

int main(int argc, char *argv[])
{
    PHYSFS_init(argv[0]);
    PHYSFS_addToSearchPath("test.zip", 0);
    int current;

    PHYSFS_file *handle = PHYSFS_openRead("dir/hide.png");
    if (handle == 0)
    {
        printf("error: handle is NULL\n");
        return 1;
    }
    const int len = PHYSFS_fileLength(handle);
    if (len != 368)
    {
        printf("error: got len=%d\n", len);
        return 1;
    }

// if comment code from "start" to "end" blocks, will be no bug.

// start ->
    if (PHYSFS_seek(handle, 368) == 0)
    {
        printf("error: PHYSFS_seek 1\n");
        return 1;
    }

    current = PHYSFS_tell(handle);
    if (current != 368)
    {
        printf("error: PHYSFS_tell 1 returned %d\n", current);
        return 1;
    }
// <- end

    if (PHYSFS_seek(handle, 0) == 0)
    {
        printf("error: PHYSFS_seek 3\n");
        return 1;
    }

    current = PHYSFS_tell(handle);
    if (current != 0)
    {
        printf("error: PHYSFS_tell 2 returned %d\n", current);
        return 1;
    }

    unsigned char buf[368];

    const int rc = PHYSFS_read(handle, buf, 1, 368);
    // here rc == 0, but must be 368
    if (rc != 368)
    {
        printf("error: PHYSFS_read %d bytes\n", rc);
        return 1;
    }

    if (PHYSFS_close(handle) == 0)
    {
        printf("error: PHYSFS_close\n");
        return 1;
    }
    printf("All checks passed\n");
    return 0;
}
